(* Replace MESON functions with one that considers hooks. *)

let (meson_hooks : (thm list -> goal -> unit) list ref) = ref [];;

let ASM_MESON_TAC ths g =
  List.iter (fun f -> f ths g) !meson_hooks;
  GEN_MESON_TAC 0 50 1 ths g;;

let MESON_TAC ths = POP_ASSUM_LIST(K ALL_TAC) THEN ASM_MESON_TAC ths;;

let MESON ths tm = prove(tm,MESON_TAC ths);;
