module Ncproof =
struct

type ('l, 'c, 'rd, 're) proof =
    Lemma
  | Reduction
  | Decomposition of 'c * 'rd * ('l * ('l, 'c, 'rd, 're) proof) list
  | Extension     of 'c * 're * ('l * ('l, 'c, 'rd, 're) proof) list

open Print
open Format

let rec pp_print_proof (fl, fc) sub f (lit, prf) =
  pp_open_vbox f 2;
  pp_print_string f (fl sub lit); pp_print_char f ' ';
  pp_print_prf (fl, fc) sub f prf;
  pp_close_box f ()
and pp_print_prf (fl, fc) sub f = function
    Reduction -> pp_print_string f "Red"
  | Lemma -> pp_print_string f "Lem"
  | Decomposition (cl, recon, prfs) ->
      pp_print_string f ("Dec " ^ fc cl);
      pp_print_proofs (fl, fc) sub f prfs
  | Extension (cl, recon, prfs) ->
      pp_print_string f ("Ext " ^ fc cl);
      pp_print_proofs (fl, fc) sub f prfs
and pp_print_proofs (fl, fc) sub f =
  List.iter (fun x -> pp_print_cut f (); pp_print_proof (fl, fc) sub f x)

let string_of_inst_litmat sub litmat = Ncprint.string_of_litmat litmat

let print_proofa (fl, fc) sub prf =
  pp_nl (pp_print_proof (fl, fc) sub) std_formatter prf

let print_proof_def sub prf =
  print_proofa (string_of_inst_litmat, Ncprint.string_of_nclause) sub prf


end
