(* Manual proof of TABLEAUX'11 nonclausal example *)

let negated = `q (f b) /\ ~p a /\ !A:t. (p A /\ ~q (f A) \/ q A /\ ~r A /\ (~q a \/ r b))`;;

let solve_rule asm =
  let conjs = CONJUNCTS asm in
  let qfb = List.nth conjs 0 in
  let npa = List.nth conjs 1 in
  let univ = List.nth conjs 2 in
  let inst = SPEC `a:t` univ in
  let TRUTH t = TAUT (mk_imp (t, `T`)) |> UNDISCH in
  let [inst1; inst2] = disjuncts (concl inst) in
  let ass1 = ASSUME inst1 in
  let pa = CONJUNCT1 ass1 in
  let ass1refuted = MP (NOT_ELIM npa) pa in
  let ass2 = ASSUME inst2 in
  let [ass21; _; ass23] = CONJUNCTS ass2 in
  let [ass23dj1; ass23dj2] = disjuncts (concl ass23) in
  let assnqa = ASSUME ass23dj1 in
  let nqaref = MP (NOT_ELIM assnqa) (ass21) in
  let assrb = ASSUME ass23dj2 in
  let inst' = SPEC `b:t` univ in
  let [inst'1; inst'2] = disjuncts (concl inst') in
  let ass'2 = ASSUME inst'2 in
  let [_; nrb; _] = CONJUNCTS ass'2 in
  let ass'2ref = MP (NOT_ELIM nrb) assrb in
  let ass'1 = ASSUME inst'1 in
  let nqfb = CONJUNCT2 ass'1 in
  let ass'1ref = MP (NOT_ELIM nqfb) qfb in
  let ass'dc = DISJ_CASES inst' ass'1ref ass'2ref in
  let rbref = ass'dc in
  let ass23ref = DISJ_CASES ass23 nqaref ass'dc in
  let allref = DISJ_CASES inst ass1refuted ass23ref in
  allref;;
(*
  TRUTH inst2;;
*)

g (mk_imp (negated, `F`));;
e DISCH_TAC;;
e (FIRST_ASSUM (fun asm -> ACCEPT_TAC (solve_rule asm)));;
