needs "cop/utils.ml";;

module Fol_term = struct

open Utils

let var v = Fvar v

let negate_lit (i, l) = (-i, l)

let rec term_max_var acc = function
    Fvar x -> max acc x
  | Fnapp (_, l) -> List.fold_left term_max_var acc l
let lit_max_var acc (_, a) = List.fold_left term_max_var acc a

let rec map_term_vars f = function
    Fvar v -> f v
  | Fnapp (p, t) -> Fnapp (p, List.map (map_term_vars f) t)
let map_lit_vars f (p, a) = (p, List.map (map_term_vars f) a)

let map_term fv fa = function
    Fvar v -> fv v
  | Fnapp (p, a) -> fa (p, a)

let rec term_ground t = map_term (const false) lit_ground t
and lit_ground (p, a) = List.for_all term_ground a


end
