(* do not only "needs" files, as e.g. tactics may get loaded earlier,
 * but may be overwritten by Flyspeck *)
loadt "eval/tactics.ml";;
loadt "eval/utils.ml";;
loadt "eval/problem.ml";;
loadt "eval/jobserver.ml";;

(* From: http://stackoverflow.com/questions/15095541/how-to-shuffle-list-in-on-in-ocaml *)
let shuffle d =
    let nd = List.map (fun c -> (Random.bits (), c)) d in
    let sond = List.sort compare nd in
    List.map snd sond
;;

let toplevel_eval timeout probsf tactic =
  Format.printf "Starting toplevel evaluation ...\n%!";
  let f = Problem.process_prob timeout tactic
  and probs = shuffle (Problem.load_probs probsf) in
  Jobserver.fallback_iter f probs
;;
