import Control.Arrow ((&&&))
import qualified Data.Set as Set
import Data.Set (Set)
import System.Environment (getArgs)
import System.Directory (getDirectoryContents)

rotate :: Int -> [a] -> [a]
rotate _ [] = []
rotate n xs = zipWith const (drop n (cycle xs)) xs

unique :: Ord a => Set a -> [Set a] -> Set a
unique s = Set.difference s . Set.unions

uniqueCombinations :: Ord a => [Set a] -> [Int]
uniqueCombinations sets = map (\ (hd : tl) -> Set.size $ unique hd tl) combs
  where combs = map (flip rotate sets) [0 ..]

main :: IO ()
main = do
  args <- getArgs
  dirs <- mapM getDirectoryContents args
  let dirS = map Set.fromList dirs
  mapM_ print (zip args $ uniqueCombinations dirS)
  putStrLn $ "Union: " ++ (show $ Set.size $ Set.unions dirS)
