module Hashek = struct

let hashek_def = new_definition `hashek = T`
let hashek_tm = `hashek`
let hashek_thm = prove (`hashek`, SIMP_TAC[hashek_def])
let hashek_prop =
  prove(`((x /\ hashek) ==> (y /\ hashek)) ==> (x ==> y)`, SIMP_TAC[hashek_def])
let hashek_eq = prove (`~ hashek <=> F`, SIMP_TAC[hashek_def])

let MARK_CONCL label =
  USE_THEN label (fun th -> UNDISCH_TAC (concl th)) THEN

  (fun g ->
     assert (is_imp (snd g));
     (* the first part of the implication *may* be a negation,
        but does not necessarily have to be *)
     assert (snd (dest_imp (snd g)) = `F`);
     ALL_TAC g) THEN

  REWRITE_TAC [TAUT `!t. (~t ==> F <=> t)`] THEN
  POP_ASSUM_LIST (fun l -> ASSUME_TAC (if l = [] then TRUTH else end_itlist CONJ l)) THEN

  (fun g -> assert (length (fst g) = 1); ALL_TAC g) THEN

  W(MAP_EVERY(UNDISCH_TAC o concl o snd) o fst) THEN
  MATCH_MP_TAC hashek_prop THEN
  DISCH_THEN (fun th -> EVERY (map ASSUME_TAC (CONJUNCTS th))) THEN
  REFUTE_THEN ASSUME_TAC

let MARK_ASSUMS = RULE_ASSUM_TAC (DISCH `hashek`)

end
